Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osgParticle::ParticleEffect Class Reference

Inheritance diagram for osgParticle::ParticleEffect:

[legend]
List of all members.

## Public Member Functions
| ParticleEffect (bool automaticSetup=true)
| ParticleEffect (const ParticleEffect &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
| return the name of the node's library.
virtual const char * | className () const
| return the name of the node's class type.
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual void | accept (osg::NodeVisitor &nv)
| Visitor Pattern : calls the apply method of a NodeVisitor with this node's type.
void | setAutomaticSetup (bool flag)
bool | getAutomaticSetup () const
void | setUseLocalParticleSystem (bool local)
bool | getUseLocalParticleSystem () const
void | setTextureFileName (const std::string &filename)
const std::string & | getTextureFileName () const
void | setDefaultParticleTemplate (const Particle &p)
const Particle & | getDefaultParticleTemplate () const
void | setPosition (const osg::Vec3 &position)
const osg::Vec3 & | getPosition () const
void | setScale (float scale)
float | getScale () const
void | setIntensity (float intensity)
float | getIntensity () const
void | setStartTime (double startTime)
double | getStartTime () const
void | setEmitterDuration (double duration)
double | getEmitterDuration () const
void | setParticleDuration (double duration)
double | getParticleDuration () const
void | setWind (const osg::Vec3 &wind)
const osg::Vec3 & | getWind () const
bool | areAllParticlesDead () const
| Get whether all particles are dead.
virtual Emitter * | getEmitter ()=0
virtual const Emitter * | getEmitter () const=0
virtual Program * | getProgram ()=0
virtual const Program * | getProgram () const=0
void | setParticleSystem (ParticleSystem *ps)
ParticleSystem * | getParticleSystem ()
const ParticleSystem * | getParticleSystem () const
virtual void | setDefaults ()
virtual void | setUpEmitterAndProgram ()=0
virtual void | buildEffect ()
## Protected Member Functions
virtual | ~ParticleEffect ()
## Protected Attributes
bool | _automaticSetup
osg::ref_ptr< ParticleSystem > | _particleSystem
bool | _useLocalParticleSystem
std::string | _textureFileName
Particle | _defaultParticleTemplate
osg::Vec3 | _position
float | _scale
float | _intensity
double | _startTime
double | _emitterDuration
osg::Vec3 | _wind

## Constructor & Destructor Documentation

osgParticle::ParticleEffect::ParticleEffect | ( | bool | automaticSetup = true | ) | `[inline]`

osgParticle::ParticleEffect::ParticleEffect | ( | const ParticleEffect & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY
| ) |

virtual osgParticle::ParticleEffect::~ParticleEffect | ( |  | ) | `[inline, protected, virtual]`

## Member Function Documentation

virtual void osgParticle::ParticleEffect::accept | ( | osg::NodeVisitor & | nv | ) | `[inline, virtual]`

| Visitor Pattern : calls the apply method of a NodeVisitor with this node's type. Reimplemented from osg::Node.

bool osgParticle::ParticleEffect::areAllParticlesDead | ( |  | ) | const`[inline]`

| Get whether all particles are dead.

virtual void osgParticle::ParticleEffect::buildEffect | ( |  | ) | `[virtual]`

virtual const char* osgParticle::ParticleEffect::className | ( |  | ) | const`[inline, virtual]`

| return the name of the node's class type. Reimplemented from osg::Node.

bool osgParticle::ParticleEffect::getAutomaticSetup | ( |  | ) | const`[inline]`

const Particle& osgParticle::ParticleEffect::getDefaultParticleTemplate | ( |  | ) | const`[inline]`

virtual const Emitter* osgParticle::ParticleEffect::getEmitter | ( |  | ) | const`[pure virtual]`

| Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

virtual Emitter* osgParticle::ParticleEffect::getEmitter | ( |  | ) | `[pure virtual]`

| Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

double osgParticle::ParticleEffect::getEmitterDuration | ( |  | ) | const`[inline]`

float osgParticle::ParticleEffect::getIntensity | ( |  | ) | const`[inline]`

double osgParticle::ParticleEffect::getParticleDuration | ( |  | ) | const`[inline]`

const ParticleSystem* osgParticle::ParticleEffect::getParticleSystem | ( |  | ) | const`[inline]`

ParticleSystem* osgParticle::ParticleEffect::getParticleSystem | ( |  | ) | `[inline]`

const osg::Vec3& osgParticle::ParticleEffect::getPosition | ( |  | ) | const`[inline]`

virtual const Program* osgParticle::ParticleEffect::getProgram | ( |  | ) | const`[pure virtual]`

| Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

virtual Program* osgParticle::ParticleEffect::getProgram | ( |  | ) | `[pure virtual]`

| Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

float osgParticle::ParticleEffect::getScale | ( |  | ) | const`[inline]`

double osgParticle::ParticleEffect::getStartTime | ( |  | ) | const`[inline]`

const std::string& osgParticle::ParticleEffect::getTextureFileName | ( |  | ) | const`[inline]`

bool osgParticle::ParticleEffect::getUseLocalParticleSystem | ( |  | ) | const`[inline]`

const osg::Vec3& osgParticle::ParticleEffect::getWind | ( |  | ) | const`[inline]`

virtual bool osgParticle::ParticleEffect::isSameKindAs | ( | const osg::Object * | obj | ) | const`[inline, virtual]`

virtual const char* osgParticle::ParticleEffect::libraryName | ( |  | ) | const`[inline, virtual]`

| return the name of the node's library. Reimplemented from osg::Node.

void osgParticle::ParticleEffect::setAutomaticSetup | ( | bool | flag | ) | `[inline]`

void osgParticle::ParticleEffect::setDefaultParticleTemplate | ( | const Particle & | p | ) |

virtual void osgParticle::ParticleEffect::setDefaults | ( |  | ) | `[virtual]`

| Reimplemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

void osgParticle::ParticleEffect::setEmitterDuration | ( | double | duration | ) |

void osgParticle::ParticleEffect::setIntensity | ( | float | intensity | ) |

void osgParticle::ParticleEffect::setParticleDuration | ( | double | duration | ) |

void osgParticle::ParticleEffect::setParticleSystem | ( | ParticleSystem * | ps | ) |

void osgParticle::ParticleEffect::setPosition | ( | const osg::Vec3 & | position | ) |

void osgParticle::ParticleEffect::setScale | ( | float | scale | ) |

void osgParticle::ParticleEffect::setStartTime | ( | double | startTime | ) |

void osgParticle::ParticleEffect::setTextureFileName | ( | const std::string & | filename | ) |

virtual void osgParticle::ParticleEffect::setUpEmitterAndProgram | ( |  | ) | `[pure virtual]`

| Implemented in osgParticle::ExplosionDebrisEffect, osgParticle::ExplosionEffect, osgParticle::FireEffect, osgParticle::SmokeEffect, and osgParticle::SmokeTrailEffect.

void osgParticle::ParticleEffect::setUseLocalParticleSystem | ( | bool | local | ) |

void osgParticle::ParticleEffect::setWind | ( | const osg::Vec3 & | wind | ) |

## Member Data Documentation

bool osgParticle::ParticleEffect::_automaticSetup`[protected]`

Particle osgParticle::ParticleEffect::_defaultParticleTemplate`[protected]`

double osgParticle::ParticleEffect::_emitterDuration`[protected]`

float osgParticle::ParticleEffect::_intensity`[protected]`

osg::ref_ptr<ParticleSystem> osgParticle::ParticleEffect::_particleSystem`[protected]`

osg::Vec3 osgParticle::ParticleEffect::_position`[protected]`

float osgParticle::ParticleEffect::_scale`[protected]`

double osgParticle::ParticleEffect::_startTime`[protected]`

std::string osgParticle::ParticleEffect::_textureFileName`[protected]`

bool osgParticle::ParticleEffect::_useLocalParticleSystem`[protected]`

osg::Vec3 osgParticle::ParticleEffect::_wind`[protected]`

The documentation for this class was generated from the following file:

- ParticleEffect